# -*- coding: utf-8 -*-
###################################################################################
#
#  Copyright 2021 Jose Gabriel Egas Ortuno
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#
#
###################################################################################
"""
This class reads the FreeCAD scripted objects and writes the adequate inpout file, to be executed by MBDyn.
The input file is stored as a text object within FreeCAD
"""
import FreeCAD
from PySide import QtGui
#from sympy import Point3D, Line3D

#__dir__ = os.path.dirname(__file__)

class Writeinpfile: 
    def __init__(self):
        MBDyn = FreeCAD.ActiveDocument.getObject("MBDyn")#Get the simulation scripted object
        ControlData = FreeCAD.ActiveDocument.getObject("ControlData")#Get the simulation scripted object
        #gravity = FreeCAD.ActiveDocument.getObjectsByLabel("gravity")#Get the gravity object. If len is zero, there is no gravity        
        #Retrieve all the structural nodes, rigid bodies, joints, etc:        
        StructuralNodes = []
        AbstractNodes = []
        RigidBodies = []
        Joints = []
        Forces = []
        Couples = []
        ScalarFunctions = []
        Drives = []
        Laws = []
        gravity = []
        Beam3s = []
        Variables = []
        Genels = []
        
#        precission = int(FreeCAD.ActiveDocument.getObjectsByLabel('MBDyn')[0].precision) #Max number of decimal places used when writing the .mbd file with values obtained from the CAD file
        #Count nodes, bodies and joints:
        for obj in FreeCAD.ActiveDocument.Objects:            
            if obj.Label.startswith('structural'):#Get all the structural nodes                
                StructuralNodes.append(obj)
                
            if obj.Label.startswith('body'):
                if(obj.type=='rigid' or obj.type=='rigid: gear'):#Only rigid bodies go into the .imp file. Dummy bodies can only exist in the CAD, these are used only for the animation for example of static and dymmy nodes.
                    RigidBodies.append(obj)
                
            if obj.Label.startswith('joint'):#Get all the joints 
                Joints.append(obj) 
                
            if obj.Label.startswith('force'):#Get all the forces
                Forces.append(obj)
                
            if obj.Label.startswith('couple'):#Get all the couples
                Couples.append(obj)

            if obj.Label.startswith('function'):#Get all the scalar functions
                ScalarFunctions.append(obj)

            if obj.Label.startswith('gravity'):#Get all the scalar functions
                gravity.append(obj)

            if obj.Label.startswith('drive'):#Get all the scalar functions
                Drives.append(obj)                            

            if obj.Label.startswith('law'):#Get all the scalar functions
                Laws.append(obj)

            if obj.Label.startswith('beam3'):#Get all the beams
                Beam3s.append(obj)
                
            if obj.Label.startswith('variables'):#Get all the beams
                Variables = obj.Text.splitlines( )
                
            if obj.Label.startswith('abstract'):#Get all the beams
                AbstractNodes.append(obj)               

            if obj.Label.startswith('genel'):#Get all the beams
                Genels.append(obj)

        listlines = []
        
        listlines.append('###################################################################################################################### \n')
        listlines.append('# MBDyn is a free and open-source general purpose multi-body dynamics software. See https://www.mbdyn.org/ for details. \n')
        listlines.append('# This input file was automatically generated by the FreeCAD dynamics workbench. \n')
        listlines.append('# To learn more about MBDyn input files, you can visit the website: https://www.sky-engin.jp/en/MBDynTutorial/index.html \n')
        listlines.append('# Details about the structure of input files can be studied in the input file manuals: https://www.mbdyn.org/?Software_Download \n')
        listlines.append('# Although MBDyn has already reached a mature stage and is used by several industries, \n')
        listlines.append('# the FreeCAD dynamics workbench is still under development, and it is likely to have bugs. \n')
        listlines.append('# Please be aware of this fact before you decide to use this input file for any critical application. \n')
        listlines.append('# If you think you have found a bug or have any suggestion, please send your comments to Jose Egas: \n')
        listlines.append('# josegegas@gmail.com \n')
        listlines.append('###################################################################################################################### \n\n')
        
        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Data Block]\n\n')      
        
        listlines.append('begin: data;\n')
        listlines.append('    problem: initial value;\n')
        listlines.append('end: data;\n\n') 
        
        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Problem Block]\n\n')
        
        listlines.append('begin: initial value;\n')
        listlines.append('    initial time: ' + str(MBDyn.initial_time.Value) + ';\n')
        listlines.append('    final time: ' + str(MBDyn.final_time.Value) + ';\n')
        listlines.append('    time step: ' + str(MBDyn.time_step.Value) + ';\n')
        listlines.append('    max iterations: ' + str(MBDyn.max_iterations) + ';\n')
        listlines.append('    tolerance: ' + str(MBDyn.tolerance) + ';\n')
        listlines.append('    derivatives tolerance: ' + str(MBDyn.derivatives_tolerance) + ';\n')
        listlines.append('    derivatives max iterations: ' + str(MBDyn.derivatives_max_iterations) + ';\n')
        listlines.append('    derivatives coefficient: ' + str(MBDyn.derivatives_coefficient) + ';\n')
        listlines.append('end: initial value;\n\n')
        
        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Control Data Block]\n\n')        
        
        listlines.append('begin: control data;\n')

        listlines.append('    default orientation: euler321;\n')

        listlines.append('    initial stiffness: '+str(ControlData.initial_position_stiffness)+', '+str(ControlData.initial_velocity_stiffness)+';\n')
        
        if(ControlData.output_frequency != 'none'):
            listlines.append('    output frequency: '+str(ControlData.output_frequency)+';\n')

        if(ControlData.skip_initial_joint_assembly == 'true'):
            listlines.append('    skip initial joint assembly;\n')
                    
        listlines.append('    structural nodes: '+str(len(StructuralNodes))+';\n')
        listlines.append('    rigid bodies: '+str(len(RigidBodies))+';\n')
        
        if(len(AbstractNodes)>0): 
            listlines.append('    abstract nodes: '+str(len(AbstractNodes))+';\n')
        
        if(len(Joints)>0):    
            listlines.append('    joints: '+str(len(Joints))+';\n')

        if(len(Forces)>0 or len(Couples)>0):    
            listlines.append('    forces: '+str(len(Forces) + len(Couples))+';\n')
                
        if(len(gravity)>0):
            listlines.append('    gravity;\n')  

        if(len(Beam3s)>0):
            listlines.append('    beams: '+str(len(Beam3s))+';\n')

        if(len(Genels)>0):
            listlines.append('    genels: '+str(len(Genels))+';\n')
            
        listlines.append('end: control data;\n\n')

        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Design Variables]\n\n') 
        
        listlines.append('    #User-defined variables\n') 
        
        for x in range(0, len(Variables)):
            listlines.append('        set: real '+Variables[x] +'\n')

        listlines.append('\n')
        listlines.append('    #Gears\n\n') 
        
        for x in range(0, len(RigidBodies)):
            if (RigidBodies[x].type=='rigid: gear'):
                listlines.append('        #body: '+RigidBodies[x].label+'\n')                
                listlines.append('            set: real mass_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].mass.Value) + '; #mass [kg]\n')
                listlines.append('            set: real volume_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].volume.getValueAs("m^3").Value) + '; #volume [m^3]\n') 
                if RigidBodies[x].teeth > 0:
                    listlines.append('            set: real teeth_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].teeth) + '; #number of teeth []\n')
                
                if RigidBodies[x].radius.Value > 0:
                    listlines.append('            set: real radius_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].radius.getValueAs("m").Value) + '; #radius [m]\n')   

                if RigidBodies[x].module.Value > 0:
                    listlines.append('            set: real module_' + RigidBodies[x].label+' = ' + str(RigidBodies[x].module.getValueAs("m").Value) + '; #module [m]\n')   
                    
                if RigidBodies[x].k_ground_spring.Value > 0:
                    listlines.append('            set: real k_ground_spring_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].k_ground_spring.Value) + '; #stiffnes coefficient of ground spring [Nm/rad]\n')                       
                    
                listlines.append('\n')

        listlines.append('    #Generic bodies\n\n') 

        for x in range(0, len(RigidBodies)):            
            if (RigidBodies[x].type=='rigid'):
                listlines.append('        #body: '+RigidBodies[x].label+'\n')
                listlines.append('            set: real mass_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].mass.Value) + '; #mass [kg]\n')            
                listlines.append('            set: real volume_' + RigidBodies[x].label+' = ' + str(RigidBodies[x].volume.getValueAs("m^3").Value) + '; #volume [m^3]\n') 
                listlines.append('\n')                      

        listlines.append('    #Cylinders\n\n') 
        
        listlines.append('    #Spheres\n\n') 

        listlines.append('    #Blocks\n\n') 
        
        listlines.append('    #Nodes: initial conditions\n\n') 
        
        for x in range(0, len(StructuralNodes)):
            if StructuralNodes[x].type=='dynamic' or StructuralNodes[x].type=='static':
                listlines.append('        #node: ' + StructuralNodes[x].label+'\n')
                listlines.append('            set: real Px_' + StructuralNodes[x].label + ' = ' + str(StructuralNodes[x].absolute_position_X.getValueAs('m').Value) + '; #X component of the absolute position [m]\n')
                listlines.append('            set: real Py_' + StructuralNodes[x].label + ' = ' + str(StructuralNodes[x].absolute_position_Y.getValueAs('m').Value) + '; #Y component of the absolute position [m]\n')
                listlines.append('            set: real Pz_' + StructuralNodes[x].label + ' = ' + str(StructuralNodes[x].absolute_position_Z.getValueAs('m').Value) + '; #Z component of the absolute position [m]\n\n')
                
                listlines.append('            set: real Vx_' + StructuralNodes[x].label + ' = ' + str(StructuralNodes[x].absolute_velocity_X.getValueAs('m/s').Value) + '; #X component of the absolute velocity [m/s]\n')
                listlines.append('            set: real Vy_' + StructuralNodes[x].label + ' = ' + str(StructuralNodes[x].absolute_velocity_Y.getValueAs('m/s').Value) + '; #Y component of the absolute velocity [m/s]\n')
                listlines.append('            set: real Vz_' + StructuralNodes[x].label + ' = ' + str(StructuralNodes[x].absolute_velocity_Z.getValueAs('m/s').Value) + '; #Z component of the absolute velocity [m/s]\n\n')
                
                listlines.append('            set: real Wx_' + StructuralNodes[x].label + ' = ' + str(FreeCAD.Units.Quantity(StructuralNodes[x].absolute_angular_velocity_X).getValueAs('rad/s').Value) + '; #X component of the absolute angular velocity [m/s]\n')
                listlines.append('            set: real Wy_' + StructuralNodes[x].label + ' = ' + str(FreeCAD.Units.Quantity(StructuralNodes[x].absolute_angular_velocity_Y).getValueAs('rad/s').Value) + '; #Y component of the absolute angular velocity [m/s]\n')
                listlines.append('            set: real Wz_' + StructuralNodes[x].label + ' = ' + str(FreeCAD.Units.Quantity(StructuralNodes[x].absolute_angular_velocity_Z).getValueAs('rad/s').Value) + '; #Z component of the absolute angular velocity [m/s]\n\n')                
                

        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Intermediate Variables]\n\n') 

        listlines.append('    #Moment of inertia and relative center of mass\n\n') 

        for x in range(0, len(RigidBodies)):
            listlines.append('        #body '+RigidBodies[x].label+': \n')            
            listlines.append('            set: real Ixx_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Ixx.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n')
            listlines.append('            set: real Ixy_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Ixy.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n')
            listlines.append('            set: real Ixz_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Ixz.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n\n')

            listlines.append('            set: real Iyx_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Iyx.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n')
            listlines.append('            set: real Iyy_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Iyy.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n')
            listlines.append('            set: real Iyz_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Iyz.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n\n')
            
            listlines.append('            set: real Izx_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Izx.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n')
            listlines.append('            set: real Izy_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Izy.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n')
            listlines.append('            set: real Izz_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].Izz.getValueAs("kg*m^2").Value) + '; #moment of inertia [kg*m^2]\n\n')
    
            listlines.append('            set: real Rx_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].relative_center_of_mass_X.getValueAs("m").Value) + '; #X component of the relative center of mass [m]\n')
            listlines.append('            set: real Ry_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].relative_center_of_mass_X.getValueAs("m").Value) + '; #Y component of the relative center of mass [m]\n')
            listlines.append('            set: real Rz_' + RigidBodies[x].label + ' = ' + str(RigidBodies[x].relative_center_of_mass_X.getValueAs("m").Value) + '; #Z component of the relative center of mass [m]\n\n')
    
        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Scalar functions]\n\n')

        for x in range(0, len(ScalarFunctions)):            
            listlines.append('   scalar function: "function:'+ ScalarFunctions[x].label +'",\n')
            listlines.append('   ' + ScalarFunctions[x].type.split(':')[0]+',\n')
            if ScalarFunctions[x].extrapolation=="do not extrapolate":
                listlines.append('   ' + ScalarFunctions[x].extrapolation+',\n')
            
            listlines.append(FreeCAD.ActiveDocument.getObjectsByLabel("points: "+ScalarFunctions[x].label)[0].Text + ';\n\n')

        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Drive callers]\n\n')

        for x in range(0, len(Drives)):            
            listlines.append('    drive caller: '+ Drives[x].label +', name,'+ '"drive:' + Drives[x].label + '", ' + Drives[x].expression +';\n\n')

        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Constitutive laws]\n\n')

        for x in range(0, len(Laws)):
            if Laws[x].type.startswith("linear elastic isotropic"): 
                if Laws[x].dimensionality=="1D":
                    listlines.append('    #"1D" scalar isotropic law: '+ Laws[x].label +';\n')
                    listlines.append('        set: real stiffness' + Laws[x].label + ' = ' + Laws[x].stiffness + ';\n')        
                    listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ', stiffness'+ Laws[x].label + ';\n\n')

                if Laws[x].dimensionality=="3D":
                    listlines.append('    #3D isotropic law: '+ Laws[x].label +';\n')
                    listlines.append('        set: real stiffness' + Laws[x].label + ' = ' + Laws[x].stiffness + ';\n')        
                    listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ', stiffness'+ Laws[x].label + ';\n\n')

                if Laws[x].dimensionality=="6D":
                    listlines.append('    #6D isotropic law: '+ Laws[x].label +';\n')
                    listlines.append('        set: real stiffness' + Laws[x].label + ' = ' + Laws[x].stiffness + ';\n')        
                    listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ', stiffness'+ Laws[x].label + ';\n\n')            

            if Laws[x].type.startswith("linear elastic generic"):
                if Laws[x].dimensionality=="1D":
                    listlines.append('    #"1D" scalar isotropic law: '+ Laws[x].label +';\n')
                    listlines.append('        set: real stiffness' + Laws[x].label + ' = ' + Laws[x].stiffness + ';\n')        
                    listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ',\n') 
                    listlines.append('                 stiffness'+ Laws[x].label + ';\n\n')

                if Laws[x].dimensionality=="3D":
                    listlines.append('    #"3D" isotropic law: '+ Laws[x].label +';\n')
                    listlines.append('        set: real stiffness_11' + Laws[x].label + ' = ' + Laws[x]._3Dsa11 + ';\n')        
                    listlines.append('        set: real stiffness_12' + Laws[x].label + ' = ' + Laws[x]._3Dsa12 + ';\n')
                    listlines.append('        set: real stiffness_13' + Laws[x].label + ' = ' + Laws[x]._3Dsa13 + ';\n')
                    listlines.append('        set: real stiffness_21' + Laws[x].label + ' = ' + Laws[x]._3Dsa21 + ';\n')        
                    listlines.append('        set: real stiffness_22' + Laws[x].label + ' = ' + Laws[x]._3Dsa22 + ';\n')
                    listlines.append('        set: real stiffness_23' + Laws[x].label + ' = ' + Laws[x]._3Dsa23 + ';\n')
                    listlines.append('        set: real stiffness_31' + Laws[x].label + ' = ' + Laws[x]._3Dsa31 + ';\n')        
                    listlines.append('        set: real stiffness_32' + Laws[x].label + ' = ' + Laws[x]._3Dsa32 + ';\n')
                    listlines.append('        set: real stiffness_33' + Laws[x].label + ' = ' + Laws[x]._3Dsa33 + ';\n')                    
                    listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ',\n') 
                    listlines.append('                 stiffness_11' + Laws[x].label + ', stiffness_12' + Laws[x].label +', stiffness_13' + Laws[x].label + ',\n')
                    listlines.append('                 stiffness_21' + Laws[x].label + ', stiffness_22' + Laws[x].label +', stiffness_23' + Laws[x].label + ',\n')
                    listlines.append('                 stiffness_31' + Laws[x].label + ', stiffness_32' + Laws[x].label +', stiffness_33' + Laws[x].label + ';\n\n')

                if Laws[x].dimensionality=="6D":
                    listlines.append('    #"6D" isotropic law: '+ Laws[x].label +';\n')
                    listlines.append('        set: real stiffness_11' + Laws[x].label + ' = ' + Laws[x]._6Dsa11 + ';\n')        
                    listlines.append('        set: real stiffness_12' + Laws[x].label + ' = ' + Laws[x]._6Dsa12 + ';\n')
                    listlines.append('        set: real stiffness_13' + Laws[x].label + ' = ' + Laws[x]._6Dsa13 + ';\n')
                    listlines.append('        set: real stiffness_14' + Laws[x].label + ' = ' + Laws[x]._6Dsa14 + ';\n')        
                    listlines.append('        set: real stiffness_15' + Laws[x].label + ' = ' + Laws[x]._6Dsa15 + ';\n')
                    listlines.append('        set: real stiffness_16' + Laws[x].label + ' = ' + Laws[x]._6Dsa16 + ';\n')

                    listlines.append('        set: real stiffness_21' + Laws[x].label + ' = ' + Laws[x]._6Dsa21 + ';\n')        
                    listlines.append('        set: real stiffness_22' + Laws[x].label + ' = ' + Laws[x]._6Dsa22 + ';\n')
                    listlines.append('        set: real stiffness_23' + Laws[x].label + ' = ' + Laws[x]._6Dsa23 + ';\n')
                    listlines.append('        set: real stiffness_24' + Laws[x].label + ' = ' + Laws[x]._6Dsa24 + ';\n')        
                    listlines.append('        set: real stiffness_25' + Laws[x].label + ' = ' + Laws[x]._6Dsa25 + ';\n')
                    listlines.append('        set: real stiffness_26' + Laws[x].label + ' = ' + Laws[x]._6Dsa26 + ';\n')

                    listlines.append('        set: real stiffness_31' + Laws[x].label + ' = ' + Laws[x]._6Dsa31 + ';\n')        
                    listlines.append('        set: real stiffness_32' + Laws[x].label + ' = ' + Laws[x]._6Dsa32 + ';\n')
                    listlines.append('        set: real stiffness_33' + Laws[x].label + ' = ' + Laws[x]._6Dsa33 + ';\n')
                    listlines.append('        set: real stiffness_34' + Laws[x].label + ' = ' + Laws[x]._6Dsa34 + ';\n')        
                    listlines.append('        set: real stiffness_35' + Laws[x].label + ' = ' + Laws[x]._6Dsa35 + ';\n')
                    listlines.append('        set: real stiffness_36' + Laws[x].label + ' = ' + Laws[x]._6Dsa36 + ';\n')

                    listlines.append('        set: real stiffness_41' + Laws[x].label + ' = ' + Laws[x]._6Dsa41 + ';\n')        
                    listlines.append('        set: real stiffness_42' + Laws[x].label + ' = ' + Laws[x]._6Dsa42 + ';\n')
                    listlines.append('        set: real stiffness_43' + Laws[x].label + ' = ' + Laws[x]._6Dsa43 + ';\n')
                    listlines.append('        set: real stiffness_44' + Laws[x].label + ' = ' + Laws[x]._6Dsa44 + ';\n')        
                    listlines.append('        set: real stiffness_45' + Laws[x].label + ' = ' + Laws[x]._6Dsa45 + ';\n')
                    listlines.append('        set: real stiffness_46' + Laws[x].label + ' = ' + Laws[x]._6Dsa46 + ';\n')

                    listlines.append('        set: real stiffness_51' + Laws[x].label + ' = ' + Laws[x]._6Dsa51 + ';\n')        
                    listlines.append('        set: real stiffness_52' + Laws[x].label + ' = ' + Laws[x]._6Dsa52 + ';\n')
                    listlines.append('        set: real stiffness_53' + Laws[x].label + ' = ' + Laws[x]._6Dsa53 + ';\n')
                    listlines.append('        set: real stiffness_54' + Laws[x].label + ' = ' + Laws[x]._6Dsa54 + ';\n')        
                    listlines.append('        set: real stiffness_55' + Laws[x].label + ' = ' + Laws[x]._6Dsa55 + ';\n')
                    listlines.append('        set: real stiffness_56' + Laws[x].label + ' = ' + Laws[x]._6Dsa56 + ';\n')

                    listlines.append('        set: real stiffness_61' + Laws[x].label + ' = ' + Laws[x]._6Dsa61 + ';\n')        
                    listlines.append('        set: real stiffness_62' + Laws[x].label + ' = ' + Laws[x]._6Dsa62 + ';\n')
                    listlines.append('        set: real stiffness_63' + Laws[x].label + ' = ' + Laws[x]._6Dsa63 + ';\n')
                    listlines.append('        set: real stiffness_64' + Laws[x].label + ' = ' + Laws[x]._6Dsa64 + ';\n')        
                    listlines.append('        set: real stiffness_65' + Laws[x].label + ' = ' + Laws[x]._6Dsa65 + ';\n')
                    listlines.append('        set: real stiffness_66' + Laws[x].label + ' = ' + Laws[x]._6Dsa66 + ';\n')
                    
                    listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ',\n') 
                    listlines.append('                 stiffness_11' + Laws[x].label + ', stiffness_12' + Laws[x].label +', stiffness_13' + Laws[x].label + ', stiffness_14' + Laws[x].label + ', stiffness_15' + Laws[x].label + ', stiffness_16' + Laws[x].label + ',\n')
                    listlines.append('                 stiffness_21' + Laws[x].label + ', stiffness_22' + Laws[x].label +', stiffness_23' + Laws[x].label + ', stiffness_24' + Laws[x].label + ', stiffness_25' + Laws[x].label + ', stiffness_26' + Laws[x].label + ',\n')
                    listlines.append('                 stiffness_31' + Laws[x].label + ', stiffness_32' + Laws[x].label +', stiffness_33' + Laws[x].label + ', stiffness_34' + Laws[x].label + ', stiffness_35' + Laws[x].label + ', stiffness_36' + Laws[x].label + ',\n')
                    listlines.append('                 stiffness_41' + Laws[x].label + ', stiffness_42' + Laws[x].label +', stiffness_43' + Laws[x].label + ', stiffness_44' + Laws[x].label + ', stiffness_45' + Laws[x].label + ', stiffness_46' + Laws[x].label + ',\n')
                    listlines.append('                 stiffness_51' + Laws[x].label + ', stiffness_52' + Laws[x].label +', stiffness_53' + Laws[x].label + ', stiffness_54' + Laws[x].label + ', stiffness_55' + Laws[x].label + ', stiffness_56' + Laws[x].label + ',\n')
                    listlines.append('                 stiffness_61' + Laws[x].label + ', stiffness_62' + Laws[x].label +', stiffness_63' + Laws[x].label + ', stiffness_64' + Laws[x].label + ', stiffness_65' + Laws[x].label + ', stiffness_66' + Laws[x].label + ';\n\n')
            
            if Laws[x].type.startswith("linear viscoelastic")  and Laws[x].dimensionality=="2D":
                listlines.append('    #Law:'+ Laws[x].label +';\n')
                listlines.append('        set: real stiffness' + Laws[x].label + ' = ' + Laws[x].stiffness + ';\n')
                listlines.append('        set: real viscosity' + Laws[x].label + ' = ' + Laws[x].viscosity + ';\n')            
                listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ', stiffness'+ Laws[x].label +', viscosity'+ Laws[x].label +';\n\n')
                

            if Laws[x].type.startswith("linear viscous") and Laws[x].dimensionality=="1D":
                listlines.append('    #Law:'+ Laws[x].label +';\n')
                listlines.append('        set: real viscosity' + Laws[x].label + ' = ' + Laws[x].viscosity + ';\n')            
                listlines.append('        constitutive law: '+ Laws[x].label +', name,'+ '"law:' + Laws[x].label + '", ' + Laws[x].dimensionality[0] + ', ' +Laws[x].type.split(",")[0] + ', viscosity'+ Laws[x].label +';\n\n')


        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Nodes Block]\n\n')        

        listlines.append('begin: nodes;\n\n')
        for x in range(0, len(AbstractNodes)):
            listlines.append('    abstract: ' + AbstractNodes[x].label + ', #<label>\n')
            listlines.append('                ' + AbstractNodes[x].additional_args + ', #<additional_args>\n')
            listlines.append('                value, ' + str(AbstractNodes[x].initial_value) + '; #<initial_value>\n\n')
            #listlines.append('    '+AbstractNodes[x].derivative_initial_value+'; #<derivative_initial_value> \n\n')            
        
        for x in range(0, len(StructuralNodes)):
            if(StructuralNodes[x].type=='dynamic'):
                listlines.append('    structural: ' + StructuralNodes[x].label+',\n')
                listlines.append('                dynamic,\n')
                listlines.append('                Px_' + StructuralNodes[x].label + ', Py_' + StructuralNodes[x].label + ', Pz_' + StructuralNodes[x].label + ', #<absolute_position> [m]\n')               
                listlines.append('                ' + StructuralNodes[x].absolute_orientation_matrix +', #<absolute_orientation_matrix>\n')
                #listlines.append('                euler, '+str(round(StructuralNodes[x].yaw.getValueAs('rad').Value,precission))+', '+str(round(StructuralNodes[x].pitch.getValueAs('rad').Value,precission))+', '+str(round(StructuralNodes[x].roll.getValueAs('rad').Value,precission))+', #<absolute_orientation_matrix> [rad]\n')
                listlines.append('                Vx_' + StructuralNodes[x].label + ', Vy_' + StructuralNodes[x].label + ', Vz_' + StructuralNodes[x].label + ', #<absolute_velocity> [m/s]\n')
                listlines.append('                Wx_' + StructuralNodes[x].label + ', Wy_' + StructuralNodes[x].label + ', Wz_' + StructuralNodes[x].label +'; #<absolute_angular_velocity> [rad/s]\n\n')                
                
            if(StructuralNodes[x].type=='static'):
                listlines.append('    structural: ' + StructuralNodes[x].label + ',\n')
                listlines.append('                static,\n')
                listlines.append('                Px_' + StructuralNodes[x].label + ', Py_' + StructuralNodes[x].label + ', Pz_' + StructuralNodes[x].label + ', #<absolute_position> [m]\n')               
                listlines.append('                ' + StructuralNodes[x].absolute_orientation_matrix + ', #<absolute_orientation_matrix>\n')
                #listlines.append('                euler, '+str(round(StructuralNodes[x].yaw.getValueAs('rad').Value,precission))+', '+str(round(StructuralNodes[x].pitch.getValueAs('rad').Value,precission))+', '+str(round(StructuralNodes[x].roll.getValueAs('rad').Value,precission))+', #<absolute_orientation_matrix> [rad]\n')
                listlines.append('                Vx_' + StructuralNodes[x].label + ', Vy_' + StructuralNodes[x].label + ', Vz_' + StructuralNodes[x].label + ', #<absolute_velocity> [m/s]\n')
                listlines.append('                Wx_' + StructuralNodes[x].label + ', Wy_' + StructuralNodes[x].label + ', Wz_' + StructuralNodes[x].label +'; #<absolute_angular_velocity> [rad/s]\n\n')                
                
            if(StructuralNodes[x].type=='dummy'):#Write all dummy nodes
                listlines.append('    structural: ' + StructuralNodes[x].label + ',\n')
                listlines.append('                dummy,\n')
                listlines.append('                ' + StructuralNodes[x].base_node + ', #<base_node_label>\n')
                listlines.append('                offset,' + str(StructuralNodes[x].relative_offset_X.getValueAs('m').Value) + ', ' + str(StructuralNodes[x].relative_offset_Y.getValueAs('m').Value) + ', ' + str(StructuralNodes[x].relative_offset_Z.getValueAs('m').Value) + ', #<relative_offset> [m]\n')
                listlines.append('                eye; #<relative_orientation_matrix> \n\n')
        
        listlines.append('end: nodes;\n\n')
        
        listlines.append('#-----------------------------------------------------------------------------\n')
        listlines.append('# [Elements Block]\n\n')             
        
        listlines.append('begin: elements;\n\n')
        
        listlines.append('    #-----------------------------------------------------------------------------\n')
        listlines.append('    # [Bodies]\n\n')
        
        for x in range(0, len(RigidBodies)):#Bodies. 
            listlines.append('        body: '+RigidBodies[x].label+',\n')
            listlines.append('              '+RigidBodies[x].node+', #<node_label> \n')
            listlines.append('              mass_'+RigidBodies[x].label+', #<mass> [kg]\n')
            listlines.append('              ' + 'Rx_' + RigidBodies[x].label + ', ' + 'Ry_' + RigidBodies[x].label + ', ' + 'Rz_' + RigidBodies[x].label + ', #<relative_center_of_mass> [m]\n')
            listlines.append('              ' + 'Ixx_'+RigidBodies[x].label+', Ixy_'+RigidBodies[x].label+', Ixz_'+RigidBodies[x].label+', #<inertia_matrix> [kg*m^2]\n')
            listlines.append('              ' + 'Iyx_'+RigidBodies[x].label+', Iyy_'+RigidBodies[x].label+', Iyz_'+RigidBodies[x].label+',\n')
            listlines.append('              ' + 'Izx_'+RigidBodies[x].label+', Izy_'+RigidBodies[x].label+', Izz_'+RigidBodies[x].label+';\n\n')
        
        listlines.append('    #-----------------------------------------------------------------------------\n')
        listlines.append('    # [Joints]\n\n')
    
        if(len(Joints)>0):     
            for x in range(0, len(Joints)):
                
                if(Joints[x].joint=='viscous body'):
                    try:
                        listlines.append('    joint: '+Joints[x].label+',\n')
                        listlines.append('           '+Joints[x].joint+',\n')
                        listlines.append('           '+Joints[x].node_label+',#<node>\n')                        
                        listlines.append('           position, reference, node, null, \n')
                        law = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].constitutive_law)[0]  
                        listlines.append('           ' + law.expression + '; #<const_law> \n\n')                   
                    except:
                        QtGui.QMessageBox.information(None,"WARNING! Viscous body joint: "+Joints[x].label,"""Please provide a 6D constitutive law.
This joint has not been added to the simulation.""")
                
                if(Joints[x].joint=='axial rotation'):   
                    try:
                        listlines.append('            joint: ' + Joints[x].label + ',\n')
                        listlines.append('                   ' + Joints[x].joint + ',\n')
                        listlines.append('                   ' + Joints[x].node_1 + ',#<node_1>\n')
                        listlines.append('                       ' + str(Joints[x].relative_offset_1_X.getValueAs("m").Value) + ', ' + str(Joints[x].relative_offset_1_Y.getValueAs("m").Value) + ', ' + str(Joints[x].relative_offset_1_Z.getValueAs("m").Value) + ', #<relative_offset_1> [m]\n')
                        listlines.append('                       hinge, ' + Joints[x].relative_orientation_matrix_1 + ', #<relative_orientation_matrix_1>\n')
                        listlines.append('                   ' + Joints[x].node_2 + ', #<node_2>\n')
                        listlines.append('                       ' + str(Joints[x].relative_offset_2_X.getValueAs("m").Value) + ', ' + str(Joints[x].relative_offset_2_Y.getValueAs("m").Value) + ', ' + str(Joints[x].relative_offset_2_Z.getValueAs("m").Value) + ', #<relative_offset_2> [m]\n')    
                        listlines.append('                       hinge, ' + Joints[x].relative_orientation_matrix_2 + ', #<relative_orientation_matrix_2>\n')
                        if Joints[x].angular_velocity != "none":
                            sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].angular_velocity)[0]  
                            if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                                listlines.append('                   string, "model::sf::' + Joints[x].angular_velocity.replace(" ", "") + '(Time) ' +Joints[x].modifier.replace(": ", "_")+ '"; #<angular_velocity> [rad/s]\n\n')
                            else:                         
                                listlines.append('                   string, "model::drive(' + sf.label + ', Time) '+Joints[x].modifier.replace(": ", "_")+'"; #<angular_velocity> [rad/s]\n\n')           
                        if Joints[x].angular_velocity == "none" or Joints[x].angular_velocity == "":
                            listlines.append('                   string, "'  + Joints[x].modifier.replace(": ", "_") + '"; #<angular_velocity> [rad/s]\n\n')                    
                    except:
                        QtGui.QMessageBox.information(None,"WARNING! Axial rotation joint: "+Joints[x].label,"""Please provide a drive or a scalar function to define the angular velocity.
This joint has not been added to the simulation.""")
                
                if(Joints[x].joint=='total joint'):                    
                    listlines.append('            joint: '+Joints[x].label+',\n')
                    listlines.append('                   '+Joints[x].joint+',\n')
                    listlines.append('                   '+Joints[x].node_1+', #<node_1_label>\n')
                    listlines.append('                       position, '+Joints[x].relative_offset_1+', #<relative_offset_1>[m]\n')
                    listlines.append('                       position orientation, '+Joints[x].rel_pos_orientation_1+', #<rel_pos_orientation_1>[rad]\n')
                    listlines.append('                       rotation orientation, '+Joints[x].rel_rot_orientation_1+', #<rel_rot_orientation_1>[rad]\n')
                    listlines.append('                   '+Joints[x].node_2+', #<node_2_label>\n')
                    listlines.append('                       position, '+Joints[x].relative_offset_2+', #<relative_offset_2>[m]\n')
                    listlines.append('                       position orientation, '+Joints[x].rel_pos_orientation_2+', #<rel_pos_orientation_2>[rad]\n')
                    listlines.append('                       rotation orientation, '+Joints[x].rel_rot_orientation_2+', #<rel_rot_orientation_2>[rad]\n')                        
                    listlines.append('                   position constraint, \n')                      
                    if Joints[x].imposed_position_axis == "1":
                        listlines.append('                       '+Joints[x].position_status+', inactive, inactive, \n')
                        if(Joints[x].imposed_relative_position == "null"):
                            listlines.append('                       null, \n')
                        else:
                            sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].imposed_relative_position)[0] 
                            if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                                listlines.append('                       single, 1., 0., 0., string, "model::sf::' + Joints[x].imposed_relative_position.replace(" ", "") + '('+ sf.independent_variable +') ' + Joints[x].imposed_position_modifier.replace(": ", "_")+ '",\n')
                            else:                         
                                listlines.append('                       single, 1., 0., 0., string, "model::drive(' + sf.label + ', Time) '+Joints[x].imposed_position_modifier.replace(": ", "_")+'",\n')           
                    
                    if Joints[x].imposed_position_axis == "2":
                        listlines.append('                       inactive, '+Joints[x].position_status+', inactive, \n') 
                        if(Joints[x].imposed_relative_position == "null"):
                            listlines.append('                       null, \n')
                        else:                        
                            sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].imposed_relative_position)[0] 
                            if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                                listlines.append('                       single, 0., 1., 0., string, "model::sf::' + Joints[x].imposed_relative_position.replace(" ", "") + '('+ sf.independent_variable +') ' + Joints[x].imposed_position_modifier.replace(": ", "_")+ '",\n')
                            else:                         
                                listlines.append('                       single, 0., 1., 0., string, "model::drive(' + sf.label + ', Time) '+Joints[x].imposed_position_modifier.replace(": ", "_")+'",\n')           
                    
                    if Joints[x].imposed_position_axis == "3":
                        listlines.append('                       inactive, inactive, '+Joints[x].position_status+', \n')
                        if(Joints[x].imposed_relative_position == "null"):
                            listlines.append('                       null, \n')
                        else:                    
                            sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].imposed_relative_position)[0]                             
                            if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                                listlines.append('                       single, 0., 0., 1., string, "model::sf::' + Joints[x].imposed_relative_position.replace(" ", "") + '('+ sf.independent_variable +') ' + Joints[x].imposed_position_modifier.replace(": ", "_")+ '",\n')
                            else:                         
                                listlines.append('                       single, 0., 0., 1., string, "model::drive(' + sf.label + ', Time) '+Joints[x].imposed_position_modifier.replace(": ", "_")+'",\n')           
                                            
                    listlines.append('                   orientation constraint, \n')  
                    if Joints[x].imposed_orientation_axis == "1":
                        listlines.append('                       '+Joints[x].orientation_status+', inactive, inactive, \n')
                        if Joints[x].imposed_relative_rotation == "null":
                            listlines.append('                       null; \n\n')
                        if Joints[x].imposed_relative_rotation == "none":
                            listlines.append('                       single, 1., 0., 0., string, "' +Joints[x].imposed_rotation_modifier.replace(": ", "_")+ '";\n\n')
                        if Joints[x].imposed_relative_rotation != "null" and Joints[x].imposed_relative_rotation != "none":
                            sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].imposed_relative_rotation)[0] 
                            if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                                listlines.append('                       single, 1., 0., 0., string, "model::sf::' + Joints[x].imposed_relative_rotation.replace(" ", "")+ '(Time) ' +Joints[x].imposed_rotation_modifier.replace(": ", "_")+ '"; \n\n')
                            else:                         
                                listlines.append('                       single, 1., 0., 0., string, "model::drive(' + sf.label + ', Time) '+Joints[x].imposed_rotation_modifier.replace(": ", "_")+'"; \n\n')           
                    
                    if Joints[x].imposed_orientation_axis == "2":
                        listlines.append('                       inactive, '+Joints[x].orientation_status+', inactive, \n')                         
                        if(Joints[x].imposed_relative_rotation == "null"):
                            listlines.append('                       null; \n\n')
                        if Joints[x].imposed_relative_rotation == "none":
                            listlines.append('                       single, 0., 1., 0., string, "' +Joints[x].imposed_rotation_modifier.replace(": ", "_")+ '";\n\n')
                        if Joints[x].imposed_relative_rotation != "null" and Joints[x].imposed_relative_rotation != "none":
                            sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].imposed_relative_rotation)[0] 
                            if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                                listlines.append('                       single, 0., 1., 0., string, "model::sf::' + Joints[x].imposed_relative_rotation.replace(" ", "")+ '(Time) ' +Joints[x].imposed_rotation_modifier.replace(": ", "_")+ '"; \n\n')
                            else:                         
                                listlines.append('                       single, 0., 1., 0., string, "model::drive(' + sf.label + ', Time) '+Joints[x].imposed_rotation_modifier.replace(": ", "_")+'"; \n\n')           
                    
                    if Joints[x].imposed_orientation_axis == "3":
                        listlines.append('                       inactive, inactive, '+Joints[x].orientation_status+', \n')
                        if(Joints[x].imposed_relative_rotation == "null"):
                            listlines.append('                       null; \n\n')
                        if Joints[x].imposed_relative_rotation == "none":
                            listlines.append('                       single, 0., 0., 1., string, "' +Joints[x].imposed_rotation_modifier.replace(": ", "_")+ '";\n\n')
                        if Joints[x].imposed_relative_rotation != "null" and Joints[x].imposed_relative_rotation != "none":               
                            sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].imposed_relative_rotation)[0]                             
                            if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                                listlines.append('                       single, 0., 0., 1., string, "model::sf::' + Joints[x].imposed_relative_rotation.replace(" ", "")+ '(Time) ' +Joints[x].imposed_rotation_modifier.replace(": ", "_")+ '"; \n\n')
                            else:                         
                                listlines.append('                       single, 0., 0., 1., string, "model::drive(' + sf.label + ', Time) '+Joints[x].imposed_rotation_modifier.replace(": ", "_")+'"; \n\n')           
                        
                if(Joints[x].joint=='revolute pin'):
                    listlines.append('            joint: ' + Joints[x].label + ',\n')
                    listlines.append('                   ' + Joints[x].joint + ',\n')
                    listlines.append('                   ' + Joints[x].node_label + ', #<node_label> \n')
                    listlines.append('                   ' + str(Joints[x].relative_offset_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Z.getValueAs('m').Value) + ', #<relative_offset> [m]\n')
                    listlines.append('                   hinge, ' + Joints[x].relative_orientation_matrix + ', #<relative_orientation_matrix> \n')
                    listlines.append('                   ' + str(Joints[x].absolute_pin_position_X.getValueAs('m').Value) + ', ' + str(Joints[x].absolute_pin_position_Y.getValueAs('m').Value) + ', ' + str(Joints[x].absolute_pin_position_Z.getValueAs('m').Value) + ', #<absolute_pin_position> [m]\n')
                    listlines.append('                   hinge, ' + Joints[x].absolute_pin_orientation_matrix + '; #<absolute_pin_orientation_matrix> \n\n')
                    
                if(Joints[x].joint=='revolute hinge'):
                    listlines.append('            joint: ' + Joints[x].label + ',\n')
                    listlines.append('                   ' + Joints[x].joint + ',\n')
                    listlines.append('                   ' + Joints[x].node_1 + ', #<node_1_label>\n')
                    listlines.append('                       ' + str(Joints[x].relative_offset_1_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_1_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_1_Z.getValueAs('m').Value) + ', #<relative_offset_1> [m]\n')  
                    listlines.append('                       hinge, ' + Joints[x].relative_orientation_matrix_1 + ', #<relative_orientation_matrix_1>\n')
                    listlines.append('                   ' + Joints[x].node_2 + ', #<node_2_label>\n')
                    listlines.append('                       ' + str(Joints[x].relative_offset_2_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_2_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_2_Z.getValueAs('m').Value) + ', #<relative_offset_2> [m]\n')  
                    listlines.append('                       hinge, ' + Joints[x].relative_orientation_matrix_2 + '; #<relative_orientation_matrix_2>\n\n')

                if(Joints[x].joint=='revolute rotation'):
                    listlines.append('            joint: ' + Joints[x].label + ', \n')
                    listlines.append('                   ' + Joints[x].joint + ', \n')
                    listlines.append('                   ' + Joints[x].node_1 + ', #<node_1_label> \n')
                    listlines.append('                       position, ' + str(Joints[x].relative_offset_1_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_1_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_1_Z.getValueAs('m').Value) + ', #<relative_offset_1> [m]\n')  
                    listlines.append('                       orientation, ' + Joints[x].orientation_matrix_1 + ', #<relative_orientation_matrix_1> \n')
                    listlines.append('                   ' + Joints[x].node_2 + ', #<node_2_label> \n')
                    listlines.append('                       position, ' + str(Joints[x].relative_offset_2_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_2_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_2_Z.getValueAs('m').Value) + ', #<relative_offset_2> [m]\n')  
                    listlines.append('                       orientation, ' + Joints[x].orientation_matrix_2 + '; #<relative_orientation_matrix_2> \n\n')

                if(Joints[x].joint=='clamp'):
                    listlines.append('            joint: ' + Joints[x].label + ',\n')
                    listlines.append('                   ' + Joints[x].joint + ',\n')
                    listlines.append('                   ' + Joints[x].node_label + ', #<node_label>\n')
                    listlines.append('                   ' + str(Joints[x].absolute_pin_position_X.getValueAs('m').Value) + ', ' + str(Joints[x].absolute_pin_position_Y.getValueAs('m').Value) + ', ' + str(Joints[x].absolute_pin_position_Z.getValueAs('m').Value) + ', #<absolute_pin_position> [m]\n')
                    listlines.append('                   euler, ' + str(Joints[x].yaw.getValueAs('rad').Value)+', ' + str(Joints[x].pitch.getValueAs('rad').Value) + ', ' + str(Joints[x].roll.getValueAs('rad').Value) + '; #<absolute_orientation_matrix> [rad]\n\n')
                    
                if(Joints[x].joint=='in line'):#in line joints
                    listlines.append('            joint: ' + Joints[x].label + ',\n')
                    listlines.append('                   ' + Joints[x].joint + ',\n')
                    listlines.append('                   ' + Joints[x].node_1 + ', #<node_1_label>\n')
                    listlines.append('                       ' + str(Joints[x].relative_line_position_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_line_position_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_line_position_Z.getValueAs('m').Value) + ', #<relative_line_position> [m]\n')    
                    listlines.append('                       ' + Joints[x].relative_orientation + ', #<relative_orientation>\n')
                    listlines.append('                   ' + Joints[x].node_2 + ', #<node_2_label>\n')                    
                    listlines.append('                       offset, ' + str(Joints[x].relative_offset_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Z.getValueAs('m').Value) + '; #<relative_offset> [m]\n\n')    

                if(Joints[x].joint=='in plane'):
                    listlines.append('            joint: ' + Joints[x].label + ', #joint label\n')
                    listlines.append('                   ' + Joints[x].joint + ',\n')
                    listlines.append('                   ' + Joints[x].node_1 + ', # node 1\n')
                    listlines.append('                       position,' + str(Joints[x].relative_plane_position_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_plane_position_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_plane_position_Z.getValueAs('m').Value) + ', #<relative_plane_position> [m]\n')    
                    listlines.append('                       ' + Joints[x].relative_normal_direction + ', #<relative_normal_direction>\n')
                    listlines.append('                   ' + Joints[x].node_2 + ', # node 2 \n')                    
                    listlines.append('                       offset, ' + str(Joints[x].relative_offset_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Z.getValueAs('m').Value) + '; #<relative_offset> [m]\n\n')    

                if(Joints[x].joint=='prismatic'):
                    listlines.append('            joint: '+Joints[x].label+',\n')
                    listlines.append('                   '+Joints[x].joint+',\n')
                    listlines.append('                   '+Joints[x].node_1+', #<node_1_label>\n')
                    listlines.append('                   '+Joints[x].node_2+'; #<node_2_label>\n\n')                                      

                if(Joints[x].joint=='deformable displacement'):
                    try:
                        cl = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].constitutive_law)[0] 
                        listlines.append('            joint: ' + Joints[x].label + ',\n')
                        listlines.append('                   deformable displacement joint,\n')
                        listlines.append('                   ' + Joints[x].node_1 + ', #<node_1_label>\n')
                        listlines.append('                       null, #offset relative to 1 [m]\n')
                        listlines.append('                   ' + Joints[x].node_2 + ', #<node_2_label>\n')         
                        listlines.append('                       null, #offset relative to 2 [m]\n')                        
                        if cl.type.startswith("linear elastic") or cl.type.startswith("linear viscoelastic"):
                            listlines.append('                   ' + cl.expression + ',\n')    
                            listlines.append('                   prestrain, single, ' + Joints[x].direction + ', const, ' + str(Joints[x].natural_lenght.getValueAs('m').Value) + ';\n\n')
                        else:
                            listlines.append('                   ' + cl.expression + ';\n\n')
                        
                    except:
                        QtGui.QMessageBox.information(None,"WARNING! Deformable displacement joint: "+Joints[x].label,"""Please provide a constitutive law.
This joint has not been added to the simulation.""")
                    
                if(Joints[x].joint=='drive hinge'):
                    try:
                        sf = FreeCAD.ActiveDocument.getObjectsByLabel(Joints[x].hinge_orientation)[0]                
                        listlines.append('            joint: ' + Joints[x].label + ',\n')
                        listlines.append('                   ' + Joints[x].joint + ',\n')
                        listlines.append('                   ' + Joints[x].node_1 + ', #<node_1_label>\n')                    
                        listlines.append('                       hinge, ' + Joints[x].orientation_matrix_1 + ', #<relative_orientation_matrix_1>\n')
                        listlines.append('                   '+Joints[x].node_2+', #<node_2_label>\n')
                        listlines.append('                       hinge, ' + Joints[x].orientation_matrix_2 + ', #<relative_orientation_matrix_2>\n')
                        listlines.append('                   single, ' + Joints[x].rotation_axis + ', #<hinge_orientation>\n')
                        if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):                        
                            listlines.append('                   string, "model::sf::' + Joints[x].hinge_orientation.replace(" ", "") + '(Time) ' +Joints[x].modifier+ '"; #<hinge_orientation> [rad]\n\n')
                        else:                         
                            listlines.append('                   please select a scalar function of one of these types: multilinear, cubicspline or chebychev \n\n')
                    except:
                        QtGui.QMessageBox.information(None,"WARNING! Drive hinge joint: "+Joints[x].label,"""Please provide a scalar function to define the hinge orientation.
This joint has not been added to the simulation.""")

                if(Joints[x].joint=='spherical hinge'):
                    listlines.append('            joint: ' + Joints[x].label + ',\n')
                    listlines.append('                   ' + Joints[x].joint + ',\n')
                    listlines.append('                   ' + Joints[x].node_1 + ', #<node_1_label>\n')                    
                    listlines.append('                      ' + str(Joints[x].relative_offset_X.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Y.getValueAs('m').Value) + ', ' + str(Joints[x].relative_offset_Z.getValueAs('m').Value) + ', ' + '#<relative_offset_1> [m]\n')   
                    listlines.append('                   ' + Joints[x].node_2 + ', #<node_2_label>\n') 
                    listlines.append('                      null; #<relative_offset_2>\n\n')                  

        listlines.append('    #-----------------------------------------------------------------------------\n')
        listlines.append('    # [Beams]\n\n')
    
        for x in range(0, len(Beam3s)):
            cl_section_1 = FreeCAD.ActiveDocument.getObjectsByLabel(Beam3s[x].constitutive_law_section_I)[0] 
            cl_section_2 = FreeCAD.ActiveDocument.getObjectsByLabel(Beam3s[x].constitutive_law_section_II)[0] 
            listlines.append('        beam3: '+Beam3s[x].label+',\n')
            listlines.append('               '+Beam3s[x].node_1_label+' , #<node_1_label>\n')
            listlines.append('               '+Beam3s[x].relative_offset_1+', #<relative_offset_1>\n')
            listlines.append('               '+Beam3s[x].node_2_label+' , #<node_2_label>\n')
            listlines.append('               '+Beam3s[x].relative_offset_2+', #<relative_offset_2>\n')                
            listlines.append('               '+Beam3s[x].node_3_label+' , #<node_3_label>\n')
            listlines.append('               '+Beam3s[x].relative_offset_3+', #<relative_offset_3>\n')    
            listlines.append('               euler, 0., 0., 0.,\n')
            listlines.append('               ' + cl_section_1.expression + ',\n')
            listlines.append('               same,\n')
            listlines.append('               ' + cl_section_2.expression + ';\n\n')
                
        
        listlines.append('    #-----------------------------------------------------------------------------\n')
        listlines.append('    # [Plugin variables]\n\n')          
       
        #Joints:    
        if(len(Joints)>0):     
            for x in range(0, len(Joints)):#set: [element, joint_4_rz, 4, joint, string="rz"];
                if (Joints[x].joint == 'axial rotation' or Joints[x].joint == 'clamp' or Joints[x].joint == 'revolute pin' or Joints[x].joint == 'revolute hinge') and Joints[x].plugin_variables != 'none':   
                    listlines.append('        #joint: '+ Joints[x].label + '\n')
                    plugins = Joints[x].plugin_variables.splitlines( )  
                    for p in range (0,len(plugins)):
                        listlines.append('            set: [element, '+plugins[p].split(": ")[0].replace('"', " ")[1:-1]+', ' +Joints[x].label+', joint,string="' + plugins[p].split(": ")[0].replace('"', " ")[:-3].replace("_", " ")[1:] + '"];\n')
                    
                    listlines.append('\n')
        
        #Nodes:        
        for x in range(0, len(StructuralNodes)):#set: [node,X_1_1,1,structural,string="X[1]"];        
            if StructuralNodes[x].plugin_variables != 'none':
                listlines.append('        #node: '+ StructuralNodes[x].label + '\n')
                plugins = StructuralNodes[x].plugin_variables.splitlines( )                
                for p in range (0,len(plugins)):
                    listlines.append('            set: [node,'+plugins[p].split(": ")[0].replace('"', " ")[1:-1]+', ' +StructuralNodes[x].label+',structural,string=' + plugins[p].split(": ")[0].split("_")[0] + '[' + plugins[p].split(": ")[0].split("_")[1] + ']"];\n')
                
                listlines.append('\n')

        listlines.append('    #-----------------------------------------------------------------------------\n')
        listlines.append('    # [Forces and couples]\n\n')          

        #Forces:
        for x in range(0, len(Forces)):                          
            listlines.append('        force: '+Forces[x].label+',\n')
            listlines.append('            '+Forces[x].type+', #<force_type>\n')
            listlines.append('            '+Forces[x].node+', #<node_label>\n')
            listlines.append('                position, '+Forces[x].relative_arm+', #<relative_arm>\n')
            listlines.append('                '+ Forces[x].force_type +', '+ Forces[x].direction +', #<force_orientation>\n')
            if Forces[x].force_value != "none": 
                sf = FreeCAD.ActiveDocument.getObjectsByLabel(Forces[x].force_value)[0]     
                if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                    listlines.append('                string, "model::sf::' + Forces[x].force_value.replace(" ", "") + '(Time) ' +Forces[x].modifier+ '"; #<force_value> [N] \n\n')
                else:                         
                    listlines.append('                string, "model::drive(' + sf.label + ', Time) '+Forces[x].modifier+'"; #<force_value> [N] \n\n')
            if Forces[x].force_value == "none" or Forces[x].force_value == "":
                listlines.append('                string, "' +Forces[x].modifier.replace(": ", "_")+ '"; #<force_value> [N] \n\n')
                           
        #Couples:
        for x in range(0, len(Couples)):                       
            listlines.append('        couple: '+Couples[x].label+',\n')
            listlines.append('            '+Couples[x].type+', #<force_type>\n')
            listlines.append('            '+Couples[x].node+', #<node_label>\n')
            listlines.append('                position, '+Couples[x].relative_arm+', #<relative_arm>\n')
            listlines.append('                single, '+Couples[x].position+', #<couple_orientation>\n')      
            if Couples[x].couple_value != "none": 
                sf = FreeCAD.ActiveDocument.getObjectsByLabel(Couples[x].couple_value)[0]  
                if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                    listlines.append('                string, "model::sf::' + Couples[x].couple_value.replace(" ", "") + '(Time) ' +Couples[x].modifier+ '"; #<couple_value> [N*m] \n\n')
                else:                         
                    listlines.append('                string, "model::drive(' + sf.label + ', Time) '+Couples[x].modifier+'"; #<couple_value> [N*m] \n\n')
            if Couples[x].couple_value == "none" or Couples[x].couple_value == "":
                listlines.append('                string, "' +Couples[x].modifier.replace(": ", "_")+ '"; #<couple_value> [N*m] \n\n')

        
        if len(gravity)==1 and gravity[0].type=='uniform': 
            try:
                sf = FreeCAD.ActiveDocument.getObjectsByLabel(gravity[0].gravity_acceleration)[0] 
                listlines.append('        gravity: '+gravity[0].type+', '+gravity[0].direction+',')
                if(sf.type.split(':')[0] == 'cubicspline' or sf.type.split(':')[0] == 'multilinear' or sf.type.split(':')[0] == 'chebychev'):
                    #listlines.append('scalar function, ' + '"' + gravity[0].gravity_acceleration + '"' + '; \n\n')
                    listlines.append('string, "model::sf::' + gravity[0].gravity_acceleration.replace(" ", "") + '(Time)"; #<couple_value> [N*m] \n\n')
                    #gravity: uniform, 0., -1., 0., string, "model::sf::function:1(Time) *1."; 
                else:  
                    listlines.append('string, "model::drive(' + sf.label + ', Time)"; #<gravity_acceleration> [m/s^2]\n\n')                  
            except:
                QtGui.QMessageBox.information(None,"WARNING! Gravity.","""Please provide a drive or a scalar function to define the gravitational acceleration.
Gravity has not been added to the simulation.""")

        else:
            for x in range(0, len(gravity)):
                listlines.append('        gravity: ' + gravity[x].type + ', origin, ' + gravity[x].origin + ', mass, ' + str(gravity[x].mass) + ', G, ' + gravity[x].G.split(" ")[x] + ';\n\n')            

        listlines.append('    #-----------------------------------------------------------------------------\n')
        listlines.append('    # [Genels]\n\n')            
        
        for x in range(0, len(Genels)):   
            if Genels[x].genel == "clamp": 
                node = FreeCAD.ActiveDocument.getObjectsByLabel(Genels[x].clamped_node)[0]                  
                listlines.append('        genel: '+Genels[x].label+',\n')
                listlines.append('            clamp,\n')
                listlines.append('                '+ node.label +',\n')
                listlines.append('                '+ node.type +',\n')
                if (Genels[x].imposed_value.startswith("drive:")):
                    dv = FreeCAD.ActiveDocument.getObjectsByLabel(Genels[x].imposed_value)[0] 
                    listlines.append('                   string, "model::drive(' + dv.label + ', Time)"; #imposed value\n\n') 
 
                if (Genels[x].imposed_value.startswith("function:")):
                    sf = FreeCAD.ActiveDocument.getObjectsByLabel(Genels[x].imposed_value)[0] 
                    listlines.append('                   string, "model::sf::function:' + sf.label + '(Time)"; #imposed value\n\n')                    
 
                if Genels[x].imposed_value.split(':')[0] != 'drive' and Genels[x].imposed_value.split(':')[0] != 'function':
                    listlines.append('                string, "' + Genels[x].imposed_value + '"; #imposed value\n\n')                    
        
        listlines.append('end: elements;\n\n')
        #Add all the lines to the FreeCAD text document: 
        FreeCAD.ActiveDocument.getObject("input_file").Text = ' '.join(listlines)
        FreeCAD.ActiveDocument.recompute()
        
        
